#####################################################################################
#
#		:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
#####################################################################################
#
#	podarok.tcl 1.1b
#
#	:
#		    
#
#	:
#		LesbiAnka & DJ_Leshiy
#
#	Fixed:
#		Adium @ RusNet
#
# 	6.10.2007
#   v1.1a Edit by Adium
#			   ,   ,
#			  "",     ,   ,
#			     +usecolors.
#			    .    
#			     .
#	v1.1b	 
#
#####################################################################################
#
#	 :
#		1)     eggdrop/scripts
#		2)   podarki.dat  eggdrop/scripts
#		3)     source scripts/podarok.tcl
#
#####################################################################################
#
#	 :
#		! -         
#		! -        
#		! <> -         
#
#####################################################################################

#    egglib_pub.tcl
if { ![info exists egglib(ver)] } {
        putlog "***********************************************"
        putlog "             egglib_pub NOT FOUND !"
        putlog "   Download last version of egglib_pub here:"
        putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
        putlog "***********************************************"
        return
}

#   egglib_pub.tcl
if { [expr {$egglib(ver) < 1.4}] } {
        putlog "***********************************************"
        putlog " YOUR VERSION OF egglib_pub IS TOO OLD !"
        putlog "   Download last version of egglib_pub here:"
        putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
        putlog "***********************************************"
        putlog " version installed : $egglib(ver)"
        putlog " version required: 1.4"
        return
}

#  
setudef flag podarok

#   
#foreach p [array names podarok *] { catch {unset podarok($p) } }
namespace eval podarok {

#      ,    
variable podarok
set podarok(name) "podarok.tcl"
set podarok(auth) "LesbiAnka & DJ_Leshiy"
set podarok(fix) "anaesthesia"
set podarok(ver) "1.2"

#  
set podarok(pfix) "!"

#     ( )
set podarok(timer) "60"

#  ,      
set podarok(phrases) {
	{ }
	{  }
	{  }
	{ }
	{ }
	{ }
	{ }
	{ }
	{ }
	{ }
	{  }
	{  }
	{ }
	{ }
	{ }
	{ }
	{ }
	{  }
	{  }
	{ }
	{ }
	{ }
	{ }
	{ }
	{  }
	{ Cosmopolitan}
	{ -2}
	{  }
	{  }
	{ }
	{ }
	{ }
	{ }
	{ }
	{ }
	{  }
	{ }
	{ }
	{ }
	{ }
	{ }
	{ }
	{ }
	{ }
	{ }
	{  }
	{  }
	{ }
	{ }
	{ }
	{ }
	{ }
	{  }
}
set podarok(present) [::egglib::readdata scripts/podarki.dat]


# 
bind pub - $podarok(pfix)	::podarok::podarit
bind pub - $podarok(pfix)	::podarok::podarok
bind pub - $podarok(pfix)	::podarok::help
bind pub - $podarok(pfix)     ::podarok::dar

#################################
} ;#ns

proc ::podarok::help {nick uhost hand chan args} {
variable podarok
	if { ![channel get $chan podarok] } {return}
	putserv "NOTICE $nick : \0034$podarok(pfix)\00314 -    \003"
	putserv "NOTICE $nick : \0034$podarok(pfix)\00314 -     \003"
	putserv "NOTICE $nick : \0034$podarok(pfix)\00314 <\0034\00314> -     \003"
}

#################################

proc ::podarok::podarit {nick uhost hand chan text} {
	global botnick
	variable podarok
	if { ![channel get $chan podarok] } {return}
	set fraza [lindex $podarok(phrases) [rand [llength $podarok(phrases)]]]

	set podaroktimer [utimers]
    foreach line $podaroktimer {
		if {"::podarok::reset $uhost" == [lindex $line 1]} {set podarok(time) [lindex $line 0]}
	}
    if { [info exists podarok(host,$uhost)] } {
		if {$podarok(time) > 0} {
		putquick "NOTICE $nick :\00310 !\0033       \0034 $chan\0033  \00314[::egglib::rus_duration [duration $podarok(time)]]\0033,   :)\003"
		return
		}
	}
    set podarok(host,$uhost) 1
    set podarok(timer,$uhost) [utimer $podarok(timer) [list ::podarok::reset $uhost ] ]

    set nicks [chanlist $chan]
    set dnick [lindex $nicks [rand [llength $nicks]]]
    while {($dnick == $nick) || ($dnick == $botnick)} {
		set dnick [lindex $nicks [rand [llength $nicks]]]
	}
	set txt "\0037  \0036$fraza \00314=> \0034$dnick\00314 <=\0037   -\00304 [lindex $podarok(present) [rand [llength $podarok(present)]]] \0037!!!\003"
	if {![channel get $chan usecolors]} {
		set txt [stripcodes c $txt]
	} else {
		putserv "PRIVMSG $chan :\001ACTION $txt\001"
	}
}

#################################

proc ::podarok::podarok {nick uhost hand chan text} {
	variable podarok
	if { ![channel get $chan podarok] } {return}
	set fraza [lindex $podarok(phrases) [rand [llength $podarok(phrases)]]]
	set podaroktimer [utimers]
    foreach line $podaroktimer {
		if {"::podarok::reset $uhost" == [lindex $line 1]} {set podarok(time) [lindex $line 0]}
    }
    if { [info exists podarok(host,$uhost)] } {
	if {$podarok(time) > 0} {
		putquick "NOTICE $nick :\00310 !\0033       \0034 $chan\0033  \00314[::egglib::rus_duration [duration $podarok(time)]]\0033,   :)\003"
		return
	}
    }
    set podarok(host,$uhost) 1
    set podarok(timer,$uhost) [utimer $podarok(timer) [list ::podarok::reset $uhost ] ]

	set txt "\0037  \0036$fraza \00314=> \0034$nick\00314 <=\0037   -\00304 [lindex $podarok(present) [rand [llength $podarok(present)]]] \0037!!!\003"
	if {![channel get $chan usecolors]} {
		set txt [stripcodes c $txt]
	} else {
		putserv "PRIVMSG $chan :\001ACTION $txt\001"
	}
}

###############################

proc ::podarok::dar {nick uhost hand chan text} {
	global botnick
	variable podarok
	if { ![channel get $chan podarok] } {return}
	set text [join [lrange [split $text] 0 end]]
	set nik [join [lindex $text 0]]
	set mylist [join [chanlist $chan]]

	regsub -all -- {([\"\$\[\]\{\}\(\)\\])} $nik {\\\1} nikk

	set chec [lsearch $mylist $nikk]
	if { $nik == $botnick } { return 0 }
	if { $nik == $nick } { putserv "NOTICE $nick :\00310      ,   ^_^\003"
		return
	}
	if { $chec == -1 } {
	putquick "NOTICE $nick :\0033 ,  \0034 $nik \0033  \0034 $chan\0033 !\003"
	return
	}
	set fraza [lindex $podarok(phrases) [rand [llength $podarok(phrases)]]]

	set podaroktimer [utimers]
    foreach line $podaroktimer {
		if {"::podarok::reset $uhost" == [lindex $line 1]} {set podarok(time) [lindex $line 0]}
    }
	if { [info exists podarok(host,$uhost)] } {
		if {$podarok(time) > 0} {
			putquick "NOTICE $nick :\00310 !\0033       \0034 $chan \0033  \00314 [::egglib::rus_duration [duration $podarok(time)]] \0033,   :))\003"
			return
		}
    }
    set podarok(host,$uhost) 1
    set podarok(timer,$uhost) [utimer $podarok(timer) [list ::podarok::reset $uhost ] ]

	set txt "\0037  \0036$fraza \00314=> \0034$nik\00314 <=\0037   -\00304 [lindex $podarok(present) [rand [llength $podarok(present)]]] \0037!!!\003"
	if {![channel get $chan usecolors]} {
		set txt [stripcodes c $txt]
	} else {
		putserv "PRIVMSG $chan :\001ACTION $txt\001"
	}
}

###############################

proc ::podarok::reset { uhost } {
	variable podarok
    catch {killutimer $podarok(timer,$uhost)}
    catch {unset podarok(timer,$uhost)}
    catch {unset podarok(host,$uhost)}
}

#putlog "$podarok(name) v.$podarok(ver) by $podarok(auth) (fixed by $podarok(fix)) LoaDeD"
putlog "Podarok.tcl loaded."